/*
 * strings.c
 * File ID: STDuuidDTS
 *
 * (C)opyleft STDyearDTS- Øyvind A. Holm <sunny@sunbase.org>
 *
 * This program is free software; you can redistribute it and/or modify it 
 * under the terms of the GNU General Public License as published by the Free 
 * Software Foundation; either version 2 of the License, or (at your option) 
 * any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for 
 * more details.
 *
 * You should have received a copy of the GNU General Public License along with 
 * this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "STDexecDTS.h"

/*
 * allocstr() - Return pointer to allocated string generated by providing 
 * printf()-like arguments. Returns NULL on error.
 */

char *allocstr(const char *format, ...)
{
	va_list ap;
	char *p;
	size_t size = BUFSIZ;

	assert(format);

	p = malloc(size);
	if (!p) {
		myerror("%s(): Cannot allocate %u bytes", /* gncov */
		        __func__, size);
		return NULL; /* gncov */
	}

	while (1) {
		int i;
		char *p2;

		va_start(ap, format);
		i = vsnprintf(p, size, format, ap);
		va_end(ap);

		if (i < 0) {
			myerror("%s(): Cannot write %s bytes" /* gncov */
			        " to memory buffer", __func__, size);
			return NULL; /* gncov */
		}

		if ((size_t)i < size)
			return p;

		size += BUFSIZ;

		p2 = realloc(p, size);
		if (!p2) {
			myerror("%s(): Cannot reallocate %u bytes", /* gncov */
			        __func__, size);
			free(p); /* gncov */
			return NULL; /* gncov */
		}
		p = p2;
	}
}

/* vim: set ts=8 sw=8 sts=8 noet fo+=w tw=79 fenc=UTF-8 : */
